//=============================================================================
//
//  CLASS AABBTree - IMPLEMENTATION
//
//=============================================================================

#define RAYTRACER_AABBTREE_CPP


//== INCLUDES =================================================================
#include "AABBTree.h"
#include "SurfaceList.h"

//== IMPLEMENTATION ========================================================== 

AABBTree::AABBTree( const SurfaceList *scene )
{
    /*
		Implementieren Sie:
		
		Aufbau des AABB-Trees zur Beschleunigung der Schnittberechnung
	*/
	
	//Beispielcode zum traversieren aller Objekte in der Szene
    m_scene = scene;
    SurfaceContainerType::const_iterator    it = m_scene->m_surfaceContainer.begin();
    SurfaceContainerType::const_iterator    it_end = m_scene->m_surfaceContainer.end();
    for( ; it != it_end; ++it )
    {
         //Jedes Objekt in der Szene besitzt die Funktion getAABB()
         //Das sollte nuetzlich sein zum Einfuegen der Objekte in
         //die Beschleunigungsdatenstruktur
         AABBox bbox = (*it)->getAABB();
    }
}


// Destructor
AABBTree::~AABBTree()
{ 
    /*
		Implementieren Sie:
		
		Aufrumen beim Lschen eines AABB-Trees
	*/
}

//-----------------------------------------------------------------------------

bool 
AABBTree::intersect(const Ray&     clRay, 
	   					const double      t0, 
						const double      t1, 
						TracingContext&    tContext ) const
{
  /*
		Implementieren Sie:
		
		Schnittberechnung mit der Szene mit Hilfe eines AABBTrees
	*/
	return false;
}