//=============================================================================
//
//  CLASS KDTree - IMPLEMENTATION
//
//=============================================================================

#define RAYTRACER_KDTREE_CPP


//== INCLUDES =================================================================
#include "KDTree.h"
#include "SurfaceList.h"

//== IMPLEMENTATION ========================================================== 

KDTree::KDTree( const SurfaceList *scene )
{
    /*
		Implementieren Sie:
		
		Aufbau des KDTrees zur Beschleunigung der Schnittberechnung
	*/
	
	//Beispielcode zum traversieren aller Objekte in der Szene
    m_scene = scene;
    SurfaceContainerType::const_iterator    it = m_scene->m_surfaceContainer.begin();
    SurfaceContainerType::const_iterator    it_end = m_scene->m_surfaceContainer.end();
    for( ; it != it_end; ++it )
    {
         //Jedes Objekt in der Szene besitzt die Funktion getAABB()
         //Das sollte nuetzlich sein zum Einfuegen der Objekte in
         //die Beschleunigungsdatenstruktur
         AABBox bbox = (*it)->getAABB();
    }
}

// Destructor
KDTree::~KDTree()
{ 
    /*
		Implementieren Sie:
		
		Aufrumen beim Lschen eines KD-Trees
	*/
}

//-----------------------------------------------------------------------------

bool 
KDTree::intersect(const Ray&     clRay, 
	   					const double      t0, 
						const double      t1, 
						TracingContext&    tContext ) const
{
  /*
		Implementieren Sie:
		
		Schnittberechnung mit der Szene mit Hilfe eines KD-Trees
	*/
	return false;
}